#ifndef _CAMERA_H

//#include "coldet.h"			// Header File For Collision Detection Library
//#include "mesh.h"
#include "3dmath.h"
//#include "entity.h"
//#include "entitylist.h"

using namespace std;

class CAMERA
{
private:
	void GenerateTransform();

public:
	CAMERA();

	VERTEX position;
	VERTEX pos_vel;

	QUATERNION dir;

	void Update();

	void Rotate(float a, float ax, float ay, float az);
	void PreRotate(float a, float ax, float ay, float az);
	
	void MoveRelative(float mx, float my, float mz);

	//for FPS movement when we don't want to move up and down
	void MoveRelativeConstrainY(float mx, float my, float mz);

	void Move(float mx, float my, float mz);
	
	void PutTransformInto(GLdouble *matrix16);
	void PutVelocityInto(GLdouble *matrix16);
	
	/*void ResetViewDir() {viewdir.LoadMultIdent();}
	QUATERNION GetViewDir() {return viewdir;}*/
	void RotateView(float a, float ax, float ay, float az);

	void LoadVelocityIdentity();
	
	void SetPosition(VERTEX newpos);
	const VERTEX & GetPosition() const {return position;}
	const VERTEX & GetVelocity() const {return pos_vel;}
	const QUATERNION & GetRotation() const {return dir;}

	void SetVelocity(VERTEX new_velocity);
	
	void Chase();
	
	//what camera mode we're in
	string cam_mode;
	int chase_ent;
	
	//frustum information
	float frustum[6][4];
	void ExtractFrustum();
};

#define _CAMERA_H
#endif
