#ifndef _VGUI_DESIGNER_H
#define _VGUI_DESIGNER_H

/* designer.h */
#include "gui.h"
#include "singleton.h"
#include "game.h"
#include "3dmath.h"
extern GAME game;

#define DESIGNER_MODE_NONE 0
#define DESIGNER_MODE_PLACE 1
#define DESIGNER_MODE_MOVE 2

namespace VGUI
{
	class Designer : public Widget
	{
	public:
		Designer() {}
		Designer( Widget* w );
		~Designer();
		void Draw();
                void Draw( float opacity );
                bool MouseOver( float x, float y );
                string MousePress( float x, float y );
                string MouseRelease( float x, float y );

		string GetFilename() { return filename; }
		void SetFilename( string new_filename ) { filename = new_filename; Load(); }
		void SetMode( int m ) { mode = m; }
		void Delete();
		void Load();
		void Save();
		void ToggleOpenClose() { game.autox_track.ToggleOpenClose(); }
	private:
		void DrawStartArrow(float x0, float y0, float x1, float y1);
		string filename;
		TEXTURE_HANDLE bg_tex, cone_tex;
		TEXTURE_HANDLE road_tex, start_arrow_tex;
		float scale;
		float cone_tex_half_w, cone_tex_half_h;
		int mode;
		VERTEX* selected_cone;
	};
}


#endif // _VGUI_DESIGNER_H
