#ifndef _SHADER_H
#define _SHADER_H

using namespace std;

#include "exception.h"
#include "pch.h"
#include "3dmath.h"

class SHADER
{
private:
	bool loaded;
	//GLhandleARB object;
	GLhandleARB program;
	GLhandleARB vertex_shader;
	GLhandleARB fragment_shader;
	string shadername;

	void LoadFileIntoString(const string & filepath, string & filestring);

public:
	SHADER() : loaded(false) {}
	~SHADER();
	
	bool Load(const string & name);
	void Enable();
	void EndScene();
	bool UploadMat16(const string & varname, float * mat16);
	bool UploadActiveShaderParameter1i(const string & param, int val);
	bool UploadActiveShaderParameter1f(const string & param, float val);
};

class SHADER_MANAGER
{
private:
	map <string, SHADER> shadermap;
	map <string, SHADER>::iterator activeshader;
	
public:
	~SHADER_MANAGER() {DeInit();}

	void Init();
	void DeInit();
	//SHADER * Load(const string & name) {return shadermap[name].Load(name);}
	bool Load(const string & name);
	//void Enable(int shader_id) {shaderlist[shader_id].Enable();}
	void BeginScene();
	void EndScene();
	void SetActiveShader(const string & name);
	//void SendObjectMatrix(MATRIX4 & matrix);
	void UploadActiveShaderParameter1i(const string & param, int val);
	void UploadActiveShaderParameter1f(const string & param, float val);
	void UploadActiveMat16(const string & varname, float * mat16);
};

#endif
