#include "bipointer.h"

#define ITERATE(ttype,target,it) for(list <ttype>::iterator it = target.begin(); it != target.end(); it++)

//notifies registrants that we have been destroyed
void BIPOINTER_TARGET::BIPOINTER_notify()
{
	ITERATE(BIPOINTER_COMMON *, registrants, i)
	{
		(*i)->InvalidatePointerTo(this);
	}
}

void BIPOINTER_TARGET::BIPOINTER_register(BIPOINTER_COMMON * newptr)
{
	registrants.push_back(newptr);
}

void BIPOINTER_TARGET::BIPOINTER_deregister(BIPOINTER_COMMON * oldptr)
{
	list < list <BIPOINTER_COMMON *>::iterator > deletelist;
	
	ITERATE(BIPOINTER_COMMON *, registrants, i)
	{
		if ((*i) == oldptr)
			deletelist.push_back(i);
	}
	
	ITERATE(list <BIPOINTER_COMMON *>::iterator, deletelist, i)
	{
		registrants.erase(*i);
	}
}
